#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 }; /* ʒu@@@ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ڌx */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* x */

/*
** eNX`
*/
#define TEXWIDTH  256                      /* eNX`̕@@@ */
#define TEXHEIGHT 256                      /* eNX`̍@@ */
static const char texture1[] = "tire.raw"; /* eNX`t@C */

/*
** 
*/
static void init(void)
{
  /* eNX`̓ǂݍ݂Ɏgz */
  GLubyte texture[TEXHEIGHT][TEXWIDTH][4];
  FILE *fp;
  
  /* eNX`摜̓ǂݍ */
  if ((fp = fopen(texture1, "rb")) != NULL) {
    fread(texture, sizeof texture, 1, fp);
    fclose(fp);
  }
  else {
    perror(texture1);
  }
  
  /* eNX`摜̓oCgPʂɋlߍ܂Ă */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
  
  /* eNX`̊蓖 */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, TEXWIDTH, TEXHEIGHT, 0,
               GL_RGBA, GL_UNSIGNED_BYTE, texture);
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* eNX` */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  
#if 0
  /* F̐ݒ */
  static const GLfloat blend[] = { 0.0, 1.0, 0.0, 1.0 };
  glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, blend);
#endif
  
  /* At@eXg̔ʊ֐ */
  glAlphaFunc(GL_GREATER, 0.5);
  
  /* ݒ */
  glClearColor(0.3, 0.3, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
  /* ̏ݒ */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
}

/* `֐̐錾 */
#include "box.h"

/*
** V[̕`
*/
static void scene(void)
{
  static const GLfloat color[] = { 1.0, 1.0, 1.0, 1.0 };  /* ގ (F) */
  
  /* ގ̐ݒ */
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, color);
  
  /* At@eXgJn */
  glEnable(GL_ALPHA_TEST);
  
  /* eNX`}bsOJn */
  glEnable(GL_TEXTURE_2D);
  
  /* ` */
  box(1.0, 1.0, 1.0);
  
  /* eNX`}bsOI */
  glDisable(GL_TEXTURE_2D);
  
  /* At@eXgI */
  glDisable(GL_ALPHA_TEST);
}


/****************************
** GLUT ̃R[obN֐ **
****************************/

/* gbN{[p֐̐錾 */
#include "trackball.h"

/* Aj[ṼTCN */
#define FRAMES 360

static void display(void)
{
  /* t[JEgĎԂƂĎg */
  static int frame = 0;                      /* t[@@@@@@@ */
  double t = (double)frame / (double)FRAMES; /* ԂƂƂ 01 ɕω */
  
  if (++frame >= FRAMES) frame = 0;
  
  /* eNX`s̐ݒ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  glTranslated(0.5, 0.5, 0.0);
  glRotated(t * 360.0, 0.0, 0.0, 1.0);
  glScaled(0.5, 0.5, 1.0);
  gluPerspective(60.0, 1.0, 1.0, 100.0);
  gluLookAt(0.0, 2.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0);
  
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ̈ʒuݒ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* _̈ړî̕Ɉړj*/
  glTranslated(0.0, 0.0, -3.0);
  
  /* gbN{[ɂ] */
  glMultMatrixd(trackballRotation());
  
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* V[̕` */
  scene();
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* gbN{[͈ */
  trackballRegion(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      trackballStop(x, y);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutIdleFunc(idle);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
